#python
import lx

def checkmorph():
	morphlist=[]
	main=lx.eval("query layerservice layers ? main")
	mmaps=lx.evalN("query layerservice vmaps ? morph")
	lx.eval("select.type vertex")
	lx.eval("select.drop vertex")
	lx.command("vert.new", x=0 , y=0 , z=0 )
	vert = lx.eval("query layerservice vert.index ? last")
	lx.eval("select.element %(main)s vertex set %(vert)s" % vars())
	lx.eval("poly.makeFace")
	lx.eval("select.type vertex")
	lx.eval("select.element %(main)s vertex set %(vert)s" % vars())
	for i,mmap in enumerate(mmaps):
		name=lx.eval("query layerservice vmap.name ? %s" % mmap)
		try:
			lx.eval("!select.vertexMap %s morf replace" % name)
		except:
			continue
		lx.eval("vert.set x %s" % (i+1))
		for v in mmaps :
			if lx.eval("query layerservice vmap.selected ? %(v)s" % vars()) : break
		v = lx.eval("query layerservice vert.vmapValue ? %(vert)s" % vars() )
		if v != None :
			morphlist.append(name)
		lx.eval("!select.vertexMap %s morf 3" % name)
	lx.command("delete")
	return morphlist

mon=lx.Monitor()
main=lx.eval("query layerservice layers ? main")
mmaps=lx.evalN("query layerservice vmaps ? morph")
find=False
for v in mmaps :
	if lx.eval("query layerservice vmap.selected ? %(v)s" % vars()) : 
		find=True
		break
if find:
	couple=[]
	selmorph=lx.eval("query layerservice vmap.name ? %s" % v)
	lx.command("select.vertexMap",name=selmorph ,type="morf",mode= 3)
	allvert=set([int(v) for v in lx.evalN("query layerservice verts ? selected")])
	if len(allvert)==0:
		allvert=set([int(v) for v in lx.evalN("query layerservice verts ? all")])
	else:
		symset=set()
		for v in list(allvert):
			sv=lx.eval("query layerservice vert.symmetric ? %s" % v)
			if sv!=None:
				symset.add(sv)
		allvert=allvert.union(symset)
	limit=set([int(v) for v in lx.evalN("query layerservice verts ? selected")])
	center=[]
	for v in allvert:
		pos=lx.eval("query layerservice vert.pos ? %s" % v)
		if pos[0]==0.0:
			center.append(v)
	center=set(center)
	allvert=list(allvert.difference(center))
	mon.init(len(allvert)+len(center))
	while len(allvert)!=0:
		mon.step(1)
		v=allvert.pop()
		symv=lx.eval("query layerservice vert.symmetric ? %s" % v)
		if symv==None : continue
		couple.append([v,symv])
		allvert.pop(allvert.index(symv))
	lx.eval("select.vertexMap \"%s\" morf replace" % selmorph)
	print couple
	for cp in couple:
		mon.step(1)
		pos1=lx.eval("query layerservice vert.vmapValue ? %s" % cp[0])
		pos2=lx.eval("query layerservice vert.vmapValue ? %s" % cp[1])
		print "---"
		print pos1
		print pos2
		if pos1!=None:
			if pos2!=None:
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[0])
				pos=lx.eval("query layerservice vert.pos ? %s" % cp[0])
				x=pos[0]-pos2[0]
				y=pos[1]+pos2[1]
				z=pos[2]+pos2[2]
				lx.eval('symmetry.state false')
				lx.eval("vert.set x [%s]" % x)
				lx.eval("vert.set y [%s]" % y)
				lx.eval("vert.set z [%s]" % z)
				lx.eval('symmetry.state true')
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[1])
				pos=lx.eval("query layerservice vert.pos ? %s" % cp[1])
				x=pos[0]-pos1[0]
				y=pos[1]+pos1[1]
				z=pos[2]+pos1[2]
				lx.eval('symmetry.state false')
				lx.eval("vert.set x [%s]" % x)
				lx.eval("vert.set y [%s]" % y)
				lx.eval("vert.set z [%s]" % z)
				lx.eval('symmetry.state true')
			else:
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[0])
				lx.eval("vertMap.clear morf")
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[1])
				pos=lx.eval("query layerservice vert.pos ? %s" % cp[1])
				x=pos[0]-pos1[0]
				y=pos[1]+pos1[1]
				z=pos[2]+pos1[2]
				lx.eval('symmetry.state false')
				lx.eval("vert.set x [%s]" % x)
				lx.eval("vert.set y [%s]" % y)
				lx.eval("vert.set z [%s]" % z)
				lx.eval('symmetry.state true')
		else:
			if pos2!=None:
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[1])
				lx.eval("vertMap.clear morf")
				lx.command("select.element",layer=main,type="vertex",mode="set",index=cp[0])
				pos=lx.eval("query layerservice vert.pos ? %s" % cp[0])
				print "pos"
				print pos
				x=pos[0]-pos2[0]
				y=pos[1]+pos2[1]
				z=pos[1]+pos2[2]
				lx.eval('symmetry.state false')
				lx.eval("vert.set x [%s]" % x)
				lx.eval("vert.set y [%s]" % y)
				lx.eval("vert.set z [%s]" % z)
				lx.eval('symmetry.state true')
	for v in list(center):
		mon.step(1)
		pos=lx.eval("query layerservice vert.vmapValue ? %s" % v)
		if pos!=None:
			lx.command("select.element",layer=main,type="vertex",mode="set",index=v)
			vpos=lx.eval("query layerservice vert.pos ? %s" % v)
			x=vpos[0]-pos[0]
			lx.eval("vert.set x [%s]" % x)
	lx.eval("select.drop vertex")
